<script lang="ts">
  import { page } from '$app/stores';
  import StringUtil from '@common/utils/StringUtil.js';
  import { onDestroy, onMount } from 'svelte';
  import { footerLinks } from '~/constants/footer-links.js';

  let { islands, games, nfts, tokens, socials } = footerLinks.main;
  let world = [];

  const updateWorldLinks = (route: string) => {
    if (route === '/world') {
      world = islands.map((data) => ({
        name: data.name,
        url: StringUtil.afterFirst(data.url, '/world'),
      }));
    } else {
      world = islands.map((data) => ({
        name: data.name,
        url: data.url,
      }));
    }
  };

  let icon = '';
  onMount(async () => {
    icon = (await import('~/lib/svgs/SVGs.js')).SVGs.common.backToTop;
  });

  // Update 'world' array when the page changes
  const unsubscribe = page.subscribe((data) => {
    updateWorldLinks(data.route.id);
  });

  // Cleanup the subscription when the component is destroyed
  onDestroy(() => {
    unsubscribe();
  });

  const onClick = () => {
    if ($page.url.pathname === '/world') {
      // go to first slide
      const startAnchor = document.querySelector('#start');
      if (startAnchor) {
        startAnchor.scrollIntoView({
          behavior: 'smooth',
        });
      }
      return;
    }

    window.scroll({
      top: 0,
      left: 0,
      behavior: 'smooth',
    });
  };
</script>

<section id="footer-nav">
  <img src="$lib/images/footer-nav.jpg" />
  <div class="main">
    <ul>
      <li><a href="/">Islands Verse</a></li>
      <li><a href="#">Islands Studio</a></li>
    </ul>
  </div>
  <div class="links">
    <div>
      <ul class="islands">
        <h4>Island</h4>
        {#each world as link}
          <li>
            <a href={link.url}>{link.name}</a>
          </li>
        {/each}
      </ul>
    </div>
    <div>
      <ul class="games">
        <h4>Games</h4>
        {#each games as link}
          <li>
            <a href={link.url}>{link.name}</a>
          </li>
        {/each}
      </ul>
    </div>
    <div>
      <ul class="nfts">
        <h4>NFT</h4>
        {#each nfts as link}
          <li>
            <a href={link.url}>{link.name}</a>
          </li>
        {/each}
      </ul>
    </div>
    <div>
      <ul class="tokens">
        <h4>Tokens</h4>
        {#each tokens as link}
          <li>
            <a href={link.url}>{link.name}</a>
          </li>
        {/each}
      </ul>
    </div>
    <div>
      <ul class="socials">
        <h4>Social</h4>
        {#each socials as link}
          <li>
            <a href={link.url}>{link.name}</a>
          </li>
        {/each}
      </ul>
    </div>
  </div>
  <div class="to-top">
    <button on:click={onClick}
      ><div>Back to top</div>
      <div><img src={icon} /></div>
    </button>
  </div>
</section>

<style lang="postcss">
  section {
    position: relative;
    display: grid;
    background: rgb(33 17 101);
    background: linear-gradient(170deg, rgb(33 17 101 / 100%) 15%, rgb(6 105 214 / 100%) 66%);
    grid-gap: 10px;
    grid-template-columns: 1fr; /* First row with one column taking 100% width */

    & > img {
      position: absolute;
      right: 0;
      bottom: 0;
    }
  }

  .main {
    width: 100%;
    padding: 20px;
    grid-column: span 3;

    ul {
      display: flex;
      justify-content: space-around;
    }
  }

  .links {
    position: relative;
    display: grid;
    margin: var(--content-margin);
    grid-column: span 2; /* Make it span two columns (80% width) */
    grid-row: 2; /* Move the second div to the second row */
    grid-template-columns: 1fr 1fr;

    div {
      margin-left: var(--content-margin);
    }

    h4 {
      color: hsl(171deg 53% 64%);
    }

    ul {
      margin-bottom: var(--content-margin);
    }
  }

  li {
    a {
      color: silver;
    }
  }

  .to-top {
    /* display: flex; */
    margin-top: var(--content-margin);
    margin-right: var(--content-margin);

    /* position: sticky; */

    /* top: 30px; */
    color: white;
    grid-column: span 1; /* Make it span one column (20% width) */
    grid-row: 2; /* Move the third div to the second row */

    /* a {
      position: sticky;
      top: 30px;
    } */

    div:first-child {
      display: none;
    }

    img {
      width: 30px;
    }
  }

  @media (width >= 768px) {
    section {
      display: flex;

      img {
        width: 40%;
      }
    }

    .main {
      width: auto;

      ul {
        flex-direction: column;

        /* display: inline-flex; */

        /* flex-direction: row; */
      }
    }

    .links {
      display: flex;
    }

    .to-top {
      position: absolute;
      right: 0;
      margin: var(--content-margin);

      button {
        display: flex;
        align-items: center;

        img {
          margin-left: 5px;
        }
      }

      div:first-child {
        display: block;
      }
    }
  }
</style>
